Index: /stable/HeuristicLab.Tests/HeuristicLab.PluginInfraStructure-3.3/TypeExtensionsTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.PluginInfraStructure-3.3/TypeExtensionsTest.cs	(revision 9885)
+++ /stable/HeuristicLab.Tests/HeuristicLab.PluginInfraStructure-3.3/TypeExtensionsTest.cs	(revision 9885)
@@ -0,0 +1,86 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections;
+using System.Collections.Generic;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.DataAnalysis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.PluginInfrastructure.Tests {
+  /// <summary>
+  /// Summary description for TypeDiscoveryTest
+  /// </summary>
+  [TestClass]
+  public class TypeExtensionsTest {
+    [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "short")]
+    public void IsSubTypeOfTest() {
+      Assert.IsTrue(typeof(int).IsSubTypeOf(typeof(object)));
+      Assert.IsTrue(typeof(IntValue).IsSubTypeOf(typeof(IItem)));
+      Assert.IsTrue(typeof(List<int>).IsSubTypeOf(typeof(object)));
+
+      Assert.IsTrue(typeof(List<int>).IsSubTypeOf(typeof(IList)));
+      Assert.IsTrue(typeof(List<>).IsSubTypeOf(typeof(IList)));
+      Assert.IsFalse(typeof(NamedItemCollection<>).IsSubTypeOf(typeof(ICollection<IItem>)));
+      Assert.IsFalse(typeof(NamedItemCollection<>).IsSubTypeOf(typeof(ICollection<NamedItem>)));
+
+
+      Assert.IsTrue(typeof(List<IItem>).IsSubTypeOf(typeof(IList<IItem>)));
+      Assert.IsFalse(typeof(IList<IntValue>).IsSubTypeOf(typeof(IList<IItem>)));
+      Assert.IsTrue(typeof(List<IItem>).IsSubTypeOf(typeof(IList<IItem>)));
+      Assert.IsFalse(typeof(ItemList<>).IsSubTypeOf(typeof(IList<IItem>)));
+      Assert.IsFalse(typeof(ItemList<>).IsSubTypeOf(typeof(List<IItem>)));
+
+      Assert.IsFalse(typeof(List<int>).IsSubTypeOf(typeof(List<>)));
+      Assert.IsTrue(typeof(List<>).IsSubTypeOf(typeof(IList<>)));
+      Assert.IsTrue(typeof(ItemList<>).IsSubTypeOf(typeof(IList<>)));
+      Assert.IsTrue(typeof(NamedItemCollection<>).IsSubTypeOf(typeof(IItemCollection<>)));
+      Assert.IsFalse(typeof(List<IntValue>).IsSubTypeOf(typeof(IList<>)));
+    }
+
+    [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "short")]
+    public void BuildTypeTest() {
+      Assert.AreEqual(typeof(List<>).BuildType(typeof(List<>)), typeof(List<>));
+      Assert.AreEqual(typeof(List<int>).BuildType(typeof(List<>)), typeof(List<int>));
+      Assert.AreEqual(typeof(List<>).BuildType(typeof(List<int>)), typeof(List<int>));
+
+      Assert.AreEqual(typeof(ICollection<>).BuildType(typeof(List<>)), typeof(ICollection<>));
+      Assert.AreEqual(typeof(ICollection<int>).BuildType(typeof(List<>)), typeof(ICollection<int>));
+      Assert.AreEqual(typeof(ICollection<>).BuildType(typeof(List<int>)), typeof(ICollection<int>));
+
+      Assert.AreEqual(typeof(ItemCollection<>).BuildType(typeof(ICollection<int>)), null);
+      Assert.AreEqual(typeof(ItemCollection<>).BuildType(typeof(Dictionary<IItem, IItem>)), null);
+      Assert.AreEqual(typeof(ItemCollection<>).BuildType(typeof(ICollection<IItem>)), typeof(ItemCollection<IItem>));
+
+      Assert.AreEqual(typeof(FixedValueParameter<>).BuildType(typeof(ItemCollection<DataAnalysisProblemData>)), null);
+      Assert.AreEqual(typeof(IFixedValueParameter<>).BuildType(typeof(ItemCollection<DoubleValue>)), typeof(IFixedValueParameter<DoubleValue>));
+      Assert.AreEqual(typeof(IFixedValueParameter<>).BuildType(typeof(ItemCollection<IItem>)), typeof(IFixedValueParameter<IItem>));
+    }
+  }
+}
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/OnlineCalculatorPerformanceTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/OnlineCalculatorPerformanceTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/OnlineCalculatorPerformanceTest.cs	(revision 9885)
@@ -23,9 +23,8 @@
 using System.Diagnostics;
 using System.Linq;
-using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Problems.DataAnalysis_34.Tests {
+namespace HeuristicLab.Problems.DataAnalysis.Tests {
   [TestClass]
   public class OnlineCalculatorPerformanceTest {
@@ -35,5 +34,4 @@
 
     private TestContext testContextInstance;
-
     /// <summary>
     ///Gets or sets the test context which provides
@@ -47,12 +45,18 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "medium")]
     public void OnlineAccuracyCalculatorPerformanceTest() {
       TestCalculatorPerfomance(OnlineAccuracyCalculator.Calculate);
     }
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "medium")]
     public void OnlineCovarianceCalculatorPerformanceTest() {
       TestCalculatorPerfomance(OnlineCovarianceCalculator.Calculate);
     }
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "medium")]
     public void OnlineMeanAbsolutePercentageErrorCalculatorPerformanceTest() {
       TestCalculatorPerfomance(OnlineMeanAbsolutePercentageErrorCalculator.Calculate);
@@ -60,12 +64,18 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "medium")]
     public void OnlineMeanSquaredErrorCalculatorPerformanceTest() {
       TestCalculatorPerfomance(OnlineMeanSquaredErrorCalculator.Calculate);
     }
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "medium")]
     public void OnlineNormalizedMeanSquaredErrorCalculatorPerformanceTest() {
       TestCalculatorPerfomance(OnlineNormalizedMeanSquaredErrorCalculator.Calculate);
     }
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "medium")]
     public void OnlinePearsonsRSquaredCalculatorPerformanceTest() {
       TestCalculatorPerfomance(OnlinePearsonsRSquaredCalculator.Calculate);
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/StatisticCalculatorsTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/StatisticCalculatorsTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/StatisticCalculatorsTest.cs	(revision 9885)
@@ -23,7 +23,6 @@
 using System.Linq;
 using HeuristicLab.Common;
-using HeuristicLab.Problems.DataAnalysis;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
-namespace HeuristicLab.Problems.DataAnalysis_34.Tests {
+namespace HeuristicLab.Problems.DataAnalysis.Tests {
 
   [TestClass()]
@@ -54,4 +53,6 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CalculateMeanAndVarianceTest() {
       System.Random random = new System.Random(31415);
@@ -85,4 +86,6 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CalculatePearsonsRSquaredTest() {
       System.Random random = new System.Random(31415);
@@ -114,5 +117,8 @@
       }
     }
-    [TestMethod]
+
+    [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CalculatePearsonsRSquaredOfConstantTest() {
       System.Random random = new System.Random(31415);
@@ -141,4 +147,6 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CalculateHoeffdingsDTest() {
       OnlineCalculatorError error;
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/ThresholdCalculatorsTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/ThresholdCalculatorsTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/ThresholdCalculatorsTest.cs	(revision 9885)
@@ -20,11 +20,13 @@
 #endregion
 
-using HeuristicLab.Problems.DataAnalysis;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
-namespace HeuristicLab.Problems.DataAnalysis_34.Tests {
+
+namespace HeuristicLab.Problems.DataAnalysis.Tests {
 
   [TestClass()]
   public class ThresholdCalculatorsTest {
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void NormalDistributionCutPointsThresholdCalculatorTest() {
 
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionCrossoverTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionCrossoverTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionCrossoverTest.cs	(revision 9885)
@@ -27,5 +27,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Problems.DataAnalysis.Symbolic;
 using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
 using HeuristicLab.Random;
@@ -33,5 +32,5 @@
 using ExecutionContext = HeuristicLab.Core.ExecutionContext;
 
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic_34.Tests {
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Tests {
   [TestClass()]
   public class SymbolicDataAnalysisExpressionCrossoverTest {
@@ -49,4 +48,6 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicDataAnalysisExpressionSemanticSimilarityCrossoverPerformanceTest() {
       var problem = new SymbolicRegressionSingleObjectiveProblem();
@@ -56,4 +57,6 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicDataAnalysisExpressionProbabilisticFunctionalCrossoverPerformanceTest() {
       var problem = new SymbolicRegressionSingleObjectiveProblem();
@@ -63,4 +66,6 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicDataAnalysisExpressionDeterministicBestCrossoverPerformanceTest() {
       var problem = new SymbolicRegressionSingleObjectiveProblem();
@@ -70,4 +75,6 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicDataAnalysisExpressionContextAwareCrossoverPerformanceTest() {
       var problem = new SymbolicRegressionSingleObjectiveProblem();
@@ -77,4 +84,6 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicDataAnalysisExpressionDepthConstrainedCrossoverPerformanceTest() {
       var problem = new SymbolicRegressionSingleObjectiveProblem();
@@ -137,5 +146,5 @@
 
       foreach (var tree in trees)
-        HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests.Util.IsValid(tree);
+        HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests.Util.IsValid(tree);
     }
   }
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs	(revision 9885)
@@ -25,8 +25,7 @@
 using System.Linq;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Problems.DataAnalysis.Symbolic;
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic_34.Tests {
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Tests {
 
 
@@ -52,12 +51,20 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicDataAnalysisExpressionTreeInterpreterTypeCoherentGrammarPerformanceTest() {
       TypeCoherentGrammarPerformanceTest(new SymbolicDataAnalysisExpressionTreeInterpreter(), 12.5e6);
     }
-    [TestMethod]
+
+    [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicDataAnalysisExpressionTreeInterpreterFullGrammarPerformanceTest() {
       FullGrammarPerformanceTest(new SymbolicDataAnalysisExpressionTreeInterpreter(), 12.5e6);
     }
-    [TestMethod]
+
+    [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicDataAnalysisExpressionTreeInterpreterArithmeticGrammarPerformanceTest() {
       ArithmeticGrammarPerformanceTest(new SymbolicDataAnalysisExpressionTreeInterpreter(), 12.5e6);
@@ -65,11 +72,19 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicDataAnalysisExpressionTreeILEmittingInterpreterTypeCoherentGrammarPerformanceTest() {
       TypeCoherentGrammarPerformanceTest(new SymbolicDataAnalysisExpressionTreeILEmittingInterpreter(), 7.5e6);
     }
-    [TestMethod]
+
+    [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicDataAnalysisExpressionTreeILEmittingInterpreterFullGrammarPerformanceTest() {
       FullGrammarPerformanceTest(new SymbolicDataAnalysisExpressionTreeILEmittingInterpreter(), 7.5e6);
     }
+
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     [TestMethod]
     public void SymbolicDataAnalysisExpressionTreeILEmittingInterpreterArithmeticGrammarPerformanceTest() {
@@ -135,4 +150,6 @@
     ///</summary>
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void SymbolicDataAnalysisExpressionTreeInterpreterEvaluateTest() {
       Dataset ds = new Dataset(new string[] { "Y", "A", "B" }, new double[,] {
@@ -158,4 +175,6 @@
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void SymbolicDataAnalysisExpressionILEmittingTreeInterpreterEvaluateTest() {
       Dataset ds = new Dataset(new string[] { "Y", "A", "B" }, new double[,] {
@@ -411,6 +430,5 @@
           try {
             Evaluate(interpreter, ds, "(psi " + x + ")", 0, alglib.psi(x));
-          }
-          catch (alglib.alglibexception) { // ignore cases where alglib throws an exception
+          } catch (alglib.alglibexception) { // ignore cases where alglib throws an exception
           }
         };
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionTreeSimplifierTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionTreeSimplifierTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionTreeSimplifierTest.cs	(revision 9885)
@@ -23,12 +23,14 @@
 using System.Collections.Generic;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Problems.DataAnalysis.Symbolic;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic_34.Tests {
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Tests {
 
   [TestClass()]
   public class SymbolicDataAnalysisExpressionTreeSimplifierTest {
+
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void SimplifierAxiomsTest() {
       SymbolicExpressionImporter importer = new SymbolicExpressionImporter();
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicExpressionImporter.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicExpressionImporter.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicExpressionImporter.cs	(revision 9885)
@@ -25,7 +25,6 @@
 using System.Linq;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Problems.DataAnalysis.Symbolic;
-
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic_34.Tests {
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Tests {
   internal class SymbolicExpressionImporter {
     private const string VARSTART = "VAR";
@@ -86,7 +85,4 @@
     StartSymbol startSymbol = new StartSymbol();
 
-    public SymbolicExpressionImporter() {
-    }
-
     internal ISymbolicExpressionTree Import(string str) {
       str = str.Replace("(", " ( ").Replace(")", " ) ");
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/Token.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/Token.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/Token.cs	(revision 9885)
@@ -22,5 +22,5 @@
 using System.Globalization;
 
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic_34.Tests {
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Tests {
   internal enum TokenSymbol { LPAR, RPAR, SYMB, NUMBER };
   internal class Token {
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/Util.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/Util.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/Util.cs	(revision 9885)
@@ -25,7 +25,6 @@
 using System.Linq;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Problems.DataAnalysis.Symbolic;
 using HeuristicLab.Random;
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic_34.Tests {
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Tests {
   internal class Util {
 
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis-3.4/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis-3.4/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis-3.4/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs	(revision 9885)
@@ -25,9 +25,8 @@
 using System.Linq;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis;
-using HeuristicLab.Problems.DataAnalysis.Symbolic_34.Tests;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Tests;
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis_34.Tests {
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis.Tests {
 
   [TestClass()]
@@ -36,28 +35,22 @@
     private const int Rows = 100;
     private const int Columns = 50;
-    private TestContext testContextInstance;
-
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
 
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicTimeSeriesPrognosisTreeInterpreterTypeCoherentGrammarPerformanceTest() {
       TypeCoherentGrammarPerformanceTest(new SymbolicTimeSeriesPrognosisExpressionTreeInterpreter("y"), 12.5e6);
     }
+
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicTimeSeriesPrognosisTreeInterpreterFullGrammarPerformanceTest() {
       FullGrammarPerformanceTest(new SymbolicTimeSeriesPrognosisExpressionTreeInterpreter("y"), 12.5e6);
     }
+
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void SymbolicTimeSeriesPrognosisTreeInterpreterArithmeticGrammarPerformanceTest() {
       ArithmeticGrammarPerformanceTest(new SymbolicTimeSeriesPrognosisExpressionTreeInterpreter("y"), 12.5e6);
@@ -122,4 +115,6 @@
     ///</summary>
     [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void SymbolicDataAnalysisExpressionTreeInterpreterEvaluateTest() {
       Dataset ds = new Dataset(new string[] { "Y", "A", "B" }, new double[,] {
@@ -144,26 +139,4 @@
     }
 
-    //[TestMethod]
-    //public void SymbolicDataAnalysisExpressionILEmittingTreeInterpreterEvaluateTest() {
-    //  Dataset ds = new Dataset(new string[] { "Y", "A", "B" }, new double[,] {
-    //    { 1.0, 1.0, 1.0 },
-    //    { 2.0, 2.0, 2.0 },
-    //    { 3.0, 1.0, 2.0 },
-    //    { 4.0, 1.0, 1.0 },
-    //    { 5.0, 2.0, 2.0 },
-    //    { 6.0, 1.0, 2.0 },
-    //    { 7.0, 1.0, 1.0 },
-    //    { 8.0, 2.0, 2.0 },
-    //    { 9.0, 1.0, 2.0 },
-    //    { 10.0, 1.0, 1.0 },
-    //    { 11.0, 2.0, 2.0 },
-    //    { 12.0, 1.0, 2.0 }
-    //  });
-
-    //  var interpreter = new SymbolicDataAnalysisExpressionTreeILEmittingInterpreter();
-    //  EvaluateTerminals(interpreter, ds);
-    //  EvaluateOperations(interpreter, ds);
-    //}
-
     private void EvaluateTerminals(ISymbolicDataAnalysisExpressionTreeInterpreter interpreter, Dataset ds) {
       // constants
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis-3.4/Util.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis-3.4/Util.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis-3.4/Util.cs	(revision 9885)
@@ -26,5 +26,6 @@
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Random;
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis_34.Tests {
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis.Tests {
   internal class Util {
     public static void InitTree(ISymbolicExpressionTree tree, MersenneTwister twister, List<string> varNames) {
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/CordeauGQAPInstanceProviderTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/CordeauGQAPInstanceProviderTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/CordeauGQAPInstanceProviderTest.cs	(revision 9885)
@@ -25,9 +25,11 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Problems.Instances_33.Tests {
+namespace HeuristicLab.Problems.Instances.Tests {
   [TestClass()]
   public class CordeauGQAPInstanceProviderTest {
 
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Problems.Instances")]
+    [TestProperty("Time", "short")]
     public void GetCordeauGQAPInstanceTest() {
       var target = new CordeauGQAPInstanceProvider();
@@ -37,6 +39,5 @@
         try {
           target.LoadData(id);
-        }
-        catch (Exception ex) {
+        } catch (Exception ex) {
           erroneousInstances.AppendLine(id.Name + ": " + ex.Message);
         }
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/ElloumiCTAPInstanceProviderTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/ElloumiCTAPInstanceProviderTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/ElloumiCTAPInstanceProviderTest.cs	(revision 9885)
@@ -25,9 +25,11 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Problems.Instances_33.Tests {
+namespace HeuristicLab.Problems.Instances.Tests {
   [TestClass()]
   public class ElloumiCTAPInstanceProviderTest {
 
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Problems.Instances")]
+    [TestProperty("Time", "short")]
     public void GetElloumiCTAPInstanceTest() {
       var target = new ElloumiCTAPInstanceProvider();
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/QAPLIBInstanceProviderTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/QAPLIBInstanceProviderTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/QAPLIBInstanceProviderTest.cs	(revision 9885)
@@ -25,9 +25,11 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Problems.Instances_33.Tests {
+namespace HeuristicLab.Problems.Instances.Tests {
   [TestClass()]
   public class QAPLIBInstanceProviderTest {
 
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Problems.Instances")]
+    [TestProperty("Time", "medium")]
     public void GetQAPLIBInstanceTest() {
       var target = new QAPLIBInstanceProvider();
@@ -37,6 +39,5 @@
         try {
           target.LoadData(id);
-        }
-        catch (Exception ex) {
+        } catch (Exception ex) {
           erroneousInstances.AppendLine(id.Name + ": " + ex.Message);
         }
@@ -47,5 +48,7 @@
     }
 
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Problems.Instances")]
+    [TestProperty("Time", "short")]
     public void GetMicroarrayQAPInstanceTest() {
       var target = new MicroarrayQAPInstanceProvider();
@@ -64,5 +67,7 @@
     }
 
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Problems.Instances")]
+    [TestProperty("Time", "short")]
     public void GetDreznerQAPInstanceTest() {
       var target = new DreznerQAPInstanceProvider();
@@ -81,5 +86,7 @@
     }
 
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Problems.Instances")]
+    [TestProperty("Time", "long")]
     public void GetTaillardQAPInstanceTest() {
       var target = new TaillardQAPInstanceProvider();
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/TSPLIBInstanceProviderTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/TSPLIBInstanceProviderTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances-3.3/TSPLIBInstanceProviderTest.cs	(revision 9885)
@@ -20,14 +20,16 @@
 #endregion
 
-
 using System;
 using System.Text;
 using HeuristicLab.Problems.Instances.TSPLIB;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
-namespace HeuristicLab.Problems.Instances_33.Tests {
+
+namespace HeuristicLab.Problems.Instances.Tests {
   [TestClass()]
   public class TSPLIBInstanceProviderTest {
 
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Problems.Instances")]
+    [TestProperty("Time", "medium")]
     public void GetTSPLIBTSPInstanceTest() {
       var target = new TSPLIBTSPInstanceProvider();
@@ -37,6 +39,5 @@
         try {
           target.LoadData(id);
-        }
-        catch (Exception ex) {
+        } catch (Exception ex) {
           erroneousInstances.AppendLine(id.Name + ": " + ex.Message);
         }
@@ -47,5 +48,7 @@
     }
 
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Problems.Instances")]
+    [TestProperty("Time", "short")]
     public void GetTSPLIBATSPInstanceTest() {
       var target = new TSPLIBATSPInstanceProvider();
@@ -55,6 +58,5 @@
         try {
           target.LoadData(id);
-        }
-        catch (Exception ex) {
+        } catch (Exception ex) {
           erroneousInstances.AppendLine(id.Name + ": " + ex.Message);
         }
@@ -65,5 +67,7 @@
     }
 
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Problems.Instances")]
+    [TestProperty("Time", "short")]
     public void GetTSPLIBCVRPInstanceTest() {
       var target = new TSPLIBCVRPInstanceProvider();
@@ -73,6 +77,5 @@
         try {
           target.LoadData(id);
-        }
-        catch (Exception ex) {
+        } catch (Exception ex) {
           erroneousInstances.AppendLine(id.Name + ": " + ex.Message);
         }
Index: /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances.DataAnalysis-3.3/ClassificationInstanceProviderTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances.DataAnalysis-3.3/ClassificationInstanceProviderTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Problems.Instances.DataAnalysis-3.3/ClassificationInstanceProviderTest.cs	(revision 9885)
@@ -22,12 +22,13 @@
 using System;
 using System.Text;
-using HeuristicLab.Problems.Instances.DataAnalysis;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Problems.Instances.DataAnalysis_34.Tests {
+namespace HeuristicLab.Problems.Instances.DataAnalysis.Tests {
   [TestClass()]
   public class ClassificationInstanceProviderTest {
 
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Problems.Instances")]
+    [TestProperty("Time", "short")]
     public void UCIInstanceTest() {
       var target = new UCIInstanceProvider();
@@ -37,6 +38,5 @@
         try {
           target.LoadData(id);
-        }
-        catch (Exception ex) {
+        } catch (Exception ex) {
           erroneousInstances.AppendLine(id.Name + ": " + ex.Message);
         }
